/* This class is a template for a fractal renderer. 
 * Subclasses are: Mandelbrot and Julia
 */

import Rect;

abstract class Fractal {

    protected Rect bounds;	//Current boundaries for fractal
    protected Rect all_bounds;  //Default boundaries for fractal
   
    public Fractal() {
    }
   
    public abstract boolean needsRegeneration();
    public abstract int[] render(int width, int height, boolean quick);
    public abstract void setBounds(Rect b);
    public abstract Rect getBounds();
    public abstract Rect getAllBounds();
    public abstract String toString();
    public abstract void setAxisLabels(java.awt.Label x, java.awt.Label y);
}
