import FractalCanvas;
import Rect;
import Mandelbrot;
import Julia;

/**
 * This is the applet's main class.<BR>
 * 
 * A fractal zoomer written as a java applet. At present time mandelbrot and
 * julia sets may be viewed, but it's easily extended with other types of
 * fractals.<BR>
 *
 * Copyright Jonas Norling 2000.<BR>
 * GNU General Public License applies
 *
 * @see FractalCanvas
 * @author Jonas Norling
 */
public class FractalApplet extends java.applet.Applet {

    public void init () {
        initComponents ();
    }

    /** This code is generated by Forte for Java 1.0.
     * called by init()
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        fractalViewer = new java.awt.Panel ();
        ymax = new java.awt.Label ();
        xmin = new java.awt.Label ();
        xmax = new java.awt.Label ();
        ymin = new java.awt.Label ();
        mandelbrot = new FractalCanvas(new Mandelbrot(), this, xmax, xmin, ymax, ymin);
        julia = new FractalCanvas(new Julia(), this, xmax, xmin, ymax, ymin);
        panel1 = new java.awt.Panel ();
        back = new java.awt.Button ();
        zoomAll = new java.awt.Button ();
        regenerate = new java.awt.Button ();
        showJulia = new java.awt.Button ();
        verticalLabel = new java.awt.Label ();
        horizontalLabel = new java.awt.Label ();
        panel3 = new java.awt.Panel ();
        iterations = new java.awt.TextField ();
        label3 = new java.awt.Label ();
        status = new java.awt.Label ();
        setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints1;
        setBackground (new java.awt.Color (204, 204, 228));
        setFont (new java.awt.Font ("Default", 0, 10));

        fractalViewer.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints2;
        fractalViewer.setFont (new java.awt.Font ("Dialog", 0, 11));
        fractalViewer.setName ("fractalViewer");
        fractalViewer.setBackground (new java.awt.Color (204, 204, 228));
        fractalViewer.setForeground (java.awt.Color.black);

          ymax.setFont (new java.awt.Font ("Default", 0, 11));
          ymax.setName ("ymax");
          ymax.setBackground (new java.awt.Color (204, 204, 228));
          ymax.setForeground (java.awt.Color.black);
          ymax.setText ("0,00000");
          ymax.setAlignment (java.awt.Label.RIGHT);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTHEAST;
          fractalViewer.add (ymax, gridBagConstraints2);
  
          xmin.setFont (new java.awt.Font ("Default", 0, 11));
          xmin.setName ("xmin");
          xmin.setBackground (new java.awt.Color (204, 204, 228));
          xmin.setForeground (java.awt.Color.black);
          xmin.setText ("0,00000");
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTHWEST;
          fractalViewer.add (xmin, gridBagConstraints2);
  
          xmax.setFont (new java.awt.Font ("Default", 0, 11));
          xmax.setName ("xmax");
          xmax.setBackground (new java.awt.Color (204, 204, 228));
          xmax.setForeground (java.awt.Color.black);
          xmax.setText ("0,00000");
          xmax.setAlignment (java.awt.Label.RIGHT);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 3;
          gridBagConstraints2.gridy = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.VERTICAL;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTHEAST;
          fractalViewer.add (xmax, gridBagConstraints2);
  
          ymin.setFont (new java.awt.Font ("Default", 0, 11));
          ymin.setName ("ymin");
          ymin.setBackground (new java.awt.Color (204, 204, 228));
          ymin.setForeground (java.awt.Color.black);
          ymin.setText ("0,00000");
          ymin.setAlignment (java.awt.Label.RIGHT);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.SOUTHEAST;
          fractalViewer.add (ymin, gridBagConstraints2);
  
          mandelbrot.setFont (new java.awt.Font ("Default", 0, 11));
          mandelbrot.setName ("mandelbrot");
          mandelbrot.setBackground (java.awt.Color.lightGray);
          fractal = (FractalCanvas)mandelbrot;
          showingType = MANDELBROT;
          fractal.setAxisLabels(horizontalLabel, verticalLabel);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.gridwidth = 3;
          gridBagConstraints2.gridheight = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.weightx = 1.0;
          gridBagConstraints2.weighty = 1.0;
          fractalViewer.add (mandelbrot, gridBagConstraints2);
  
          julia.setFont (new java.awt.Font ("Default", 0, 11));
          julia.setName ("julia");
          julia.setBackground (java.awt.Color.lightGray);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.gridwidth = 3;
          gridBagConstraints2.gridheight = 3;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
          gridBagConstraints2.weightx = 1.0;
          gridBagConstraints2.weighty = 1.0;
          fractalViewer.add (julia, gridBagConstraints2);
  
          panel1.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints3;
          panel1.setFont (new java.awt.Font ("Default", 0, 11));
          panel1.setBackground (new java.awt.Color (204, 204, 228));
          panel1.setForeground (java.awt.Color.black);
  
            back.setFont (new java.awt.Font ("Default", 0, 11));
            back.setLabel ("<-");
            back.setName ("back");
            back.setBackground (new java.awt.Color (204, 204, 228));
            back.setForeground (java.awt.Color.black);
            back.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    backClicked (evt);
                }
            }
            );
    
            gridBagConstraints3 = new java.awt.GridBagConstraints ();
            panel1.add (back, gridBagConstraints3);
    
            zoomAll.setFont (new java.awt.Font ("Default", 0, 11));
            zoomAll.setLabel ("Visa hela");
            zoomAll.setActionCommand ("zoomAll");
            zoomAll.setName ("zoomAll");
            zoomAll.setBackground (new java.awt.Color (204, 204, 228));
            zoomAll.setForeground (java.awt.Color.black);
            zoomAll.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    zoomAllClicked (evt);
                }
            }
            );
    
            gridBagConstraints3 = new java.awt.GridBagConstraints ();
            gridBagConstraints3.gridx = 1;
            gridBagConstraints3.gridy = 0;
            gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
            panel1.add (zoomAll, gridBagConstraints3);
    
            regenerate.setFont (new java.awt.Font ("Default", 0, 11));
            regenerate.setLabel ("Regenerera");
            regenerate.setActionCommand ("regenerate");
            regenerate.setName ("regenerate");
            regenerate.setBackground (new java.awt.Color (204, 204, 228));
            regenerate.setForeground (java.awt.Color.black);
            regenerate.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    regenerateClicked (evt);
                }
            }
            );
    
            gridBagConstraints3 = new java.awt.GridBagConstraints ();
            gridBagConstraints3.gridx = 2;
            gridBagConstraints3.gridy = 0;
            gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
            gridBagConstraints3.weightx = 0.1;
            panel1.add (regenerate, gridBagConstraints3);
    
            showJulia.setFont (new java.awt.Font ("Default", 0, 11));
            showJulia.setLabel ("Visa julia-m\u00e4ngd");
            showJulia.setName ("showJulia");
            showJulia.setBackground (new java.awt.Color (204, 204, 228));
            showJulia.setForeground (java.awt.Color.black);
            showJulia.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                    showJuliaClicked (evt);
                }
            }
            );
    
            gridBagConstraints3 = new java.awt.GridBagConstraints ();
            gridBagConstraints3.gridx = 3;
            gridBagConstraints3.gridy = 0;
            gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
            gridBagConstraints3.weightx = 0.1;
            panel1.add (showJulia, gridBagConstraints3);
    
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 4;
          gridBagConstraints2.gridwidth = 4;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          fractalViewer.add (panel1, gridBagConstraints2);
  
          verticalLabel.setFont (new java.awt.Font ("Default", 0, 11));
          verticalLabel.setName ("verticallabel");
          verticalLabel.setBackground (new java.awt.Color (204, 204, 228));
          verticalLabel.setForeground (java.awt.Color.black);
          verticalLabel.setText ("Im c");
          verticalLabel.setAlignment (java.awt.Label.RIGHT);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
          gridBagConstraints2.weighty = 0.1;
          fractalViewer.add (verticalLabel, gridBagConstraints2);
  
          horizontalLabel.setFont (new java.awt.Font ("Default", 0, 11));
          horizontalLabel.setName ("horizontallabel");
          horizontalLabel.setBackground (new java.awt.Color (204, 204, 228));
          horizontalLabel.setForeground (java.awt.Color.black);
          horizontalLabel.setText ("Re c");
          horizontalLabel.setAlignment (java.awt.Label.RIGHT);
  
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 2;
          gridBagConstraints2.gridy = 3;
          gridBagConstraints2.weightx = 0.1;
          fractalViewer.add (horizontalLabel, gridBagConstraints2);
  
          panel3.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints4;
          panel3.setFont (new java.awt.Font ("Dialog", 0, 11));
          panel3.setBackground (new java.awt.Color (204, 204, 228));
          panel3.setForeground (java.awt.Color.black);
  
            iterations.setBackground (new java.awt.Color (187, 187, 209));
            iterations.setName ("iterations");
            iterations.setFont (new java.awt.Font ("Dialog", 0, 11));
            iterations.setColumns (3);
            iterations.setForeground (java.awt.Color.black);
            iterations.setText ("50");
            iterations.addTextListener (new java.awt.event.TextListener () {
                public void textValueChanged (java.awt.event.TextEvent evt) {
                    iterationsChanged (evt);
                }
            }
            );
    
            gridBagConstraints4 = new java.awt.GridBagConstraints ();
            gridBagConstraints4.gridx = 1;
            gridBagConstraints4.gridy = 0;
            gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
            panel3.add (iterations, gridBagConstraints4);
    
            label3.setFont (new java.awt.Font ("Dialog", 0, 11));
            label3.setBackground (new java.awt.Color (204, 204, 228));
            label3.setForeground (java.awt.Color.black);
            label3.setText ("max iterationer");
    
            gridBagConstraints4 = new java.awt.GridBagConstraints ();
            gridBagConstraints4.gridx = 0;
            gridBagConstraints4.gridy = 0;
            gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
            panel3.add (label3, gridBagConstraints4);
    
            status.setFont (new java.awt.Font ("Dialog", 0, 10));
            status.setName ("status");
            status.setBackground (new java.awt.Color (204, 204, 228));
            status.setForeground (java.awt.Color.black);
            status.setText ("Mandelbrotm\u00e4ngd: z = z**2 + c");
            status.setAlignment (java.awt.Label.RIGHT);
    
            gridBagConstraints4 = new java.awt.GridBagConstraints ();
            gridBagConstraints4.gridx = 2;
            gridBagConstraints4.gridy = 0;
            gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints4.anchor = java.awt.GridBagConstraints.EAST;
            gridBagConstraints4.weightx = 0.1;
            panel3.add (status, gridBagConstraints4);
    
          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 5;
          gridBagConstraints2.gridwidth = 4;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          fractalViewer.add (panel3, gridBagConstraints2);
  

        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add (fractalViewer, gridBagConstraints1);

    }//GEN-END:initComponents

  private void showJuliaClicked (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showJuliaClicked
    if (showingType == MANDELBROT) {
        Rect point = new Rect();
        
        point = fractal.getPoint();
        
        mandelbrot.setVisible(false); mandelbrot.setEnabled(false);
        julia.setVisible(true); julia.setEnabled(true);
        fractal = (FractalCanvas)julia;
        iterations.setText((new Integer(fractal.getIterations())).toString());
        
        fractal.setAxisLabels(horizontalLabel, verticalLabel);
        Julia juliaRenderer = (Julia)fractal.getRenderer();
        juliaRenderer.setC(point.getX(), point.getY());
        fractal.clearZoomHistory();
        fractal.zoomAll();
        
        setStatusBar("Julia-mngd fr c=" + RoundedNumber.getRoundedNumber(point.getX()) +
                     "+" + RoundedNumber.getRoundedNumber(point.getY()) + "i.");
        
        showJulia.setLabel("Visa Mandelbrot-mngd");
        showingType = JULIA;
    } else if (showingType == JULIA) {        
        julia.setVisible(false); julia.setEnabled(false);
        mandelbrot.setVisible(true); mandelbrot.setEnabled(true);
        fractal = (FractalCanvas)mandelbrot;
        iterations.setText((new Integer(fractal.getIterations())).toString());
        
        fractal.setAxisLabels(horizontalLabel, verticalLabel);
        
        setStatusBar("Mandelbrotmngd: z = z**2 + c");
        
        showJulia.setLabel("Visa Julia-mngd");
        showingType = MANDELBROT;
    }
  }//GEN-LAST:event_showJuliaClicked

  private void backClicked (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backClicked
        fractal.zoomLast();
  }//GEN-LAST:event_backClicked

  private void iterationsChanged (java.awt.event.TextEvent evt) {//GEN-FIRST:event_iterationsChanged
    fractal.setIterations((new Integer(iterations.getText())).intValue());
  }//GEN-LAST:event_iterationsChanged

  private void regenerateClicked (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regenerateClicked
    fractal.setFractalBounds(fractal.getNewBounds());
    fractal.repaint();
  }//GEN-LAST:event_regenerateClicked

  private void zoomAllClicked (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomAllClicked
    fractal.zoomAll();
    fractal.repaint();
  }//GEN-LAST:event_zoomAllClicked

  public void setEnabled(boolean enabled) {
    regenerate.setEnabled(enabled);
    zoomAll.setEnabled(enabled);
    back.setEnabled(enabled);
    iterations.setEnabled(enabled);
    showJulia.setEnabled(enabled);
  }

  public void setStatusBar(String text) {
    status.setText(text);
  }
  

private static final int MANDELBROT = 0;
private static final int JULIA = 1;
private int showingType;
private FractalCanvas fractal;

// Variables declaration - do not modify//GEN-BEGIN:variables
private java.awt.Panel fractalViewer;
private java.awt.Label ymax;
private java.awt.Label xmin;
private java.awt.Label xmax;
private java.awt.Label ymin;
private java.awt.Canvas mandelbrot;
private java.awt.Canvas julia;
private java.awt.Panel panel1;
private java.awt.Button back;
private java.awt.Button zoomAll;
private java.awt.Button regenerate;
private java.awt.Button showJulia;
private java.awt.Label verticalLabel;
private java.awt.Label horizontalLabel;
private java.awt.Panel panel3;
private java.awt.TextField iterations;
private java.awt.Label label3;
private java.awt.Label status;
// End of variables declaration//GEN-END:variables

}
