/* This class represents the settings necesary for the rendering of a fractal
 * (currently only for a mandelbrot set) and a buffer to render it to.
 * Objects of this class are used to cache fractals.
 */

import Rect;

class FractalData {

   public int[] buff;
   protected int buffW, buffH;
   protected Rect bounds;
   protected int iterations;
   
   public FractalData() {
   	buff = null;
   	bounds = null;
   }

   public FractalData(int width, int height, int iter, Rect b) {
      buff = null;
      setIterations(iter);
      setSize(width, height);
      setBounds(b);
   }
   
   public void setIterations(int iter) {
      iterations = iter;
   }
   
   public void setSize(int width, int height) {
      buffW = width;
      buffH = height;
      buff = new int[width*height];
   }
   
   public void setBounds(Rect x) {
      bounds = new Rect(x);
   }

   public boolean equals(Object x) {
      if (x instanceof FractalData) {
          if (bounds != null && ((FractalData)x).bounds != null) {
	      return (((FractalData)x).bounds.equals(bounds) &&
	              ((FractalData)x).buffW == buffW && ((FractalData)x).buffH == buffH &&
		      ((FractalData)x).iterations == iterations);
	  }
      }
      return (false);
   }
}
