/* This class represents a stack of limited size. When the limit is reached, the
   bottom-most object is discarded.
   Implementation would have been easy using java.util.LinkedList introduced in JDK 1.2,
   but as older JDKs don't support that class, a work-around is needed.
*/

import FractalData;

public class SizedStack {

    protected java.util.Vector list;
    protected int size;
    
    public SizedStack(int _size) {
        size = _size;
        list = new java.util.Vector();
    }

    public void push(Object obj) {
        list.addElement(obj);
        if (list.size() > size)
            list.removeElementAt(0);
    }
    
    public Object pop() {
        Object obj = list.elementAt(list.size()-1);
        list.removeElementAt(list.size()-1);
        return (obj);
    }
    
    public Object peek() {
        return (list.lastElement());
    }
    
    public boolean empty() {
        return (list.isEmpty());
    }
    
    public void clear() {
        list.setSize(0);
    }

    public boolean contains(Object obj) {
       return (list.contains(obj));
    }

    public int indexOf(Object obj) {
        return (list.indexOf(obj));
    }
   
    public Object getElement(int i) {
       return (list.elementAt(i));
    }
   
}
